// AgentModelSwarm.h


/*
static char Id="$Id: AgentModelSwarm.h,v 1.4 1998/04/24 21:19:11 mgd Exp $"
*/

#import <objectbase/Swarm.h>
#import "AgentProbaCamera.h"
#import "WorldObject.h"
#import <space.h>
#import <activity.h>
#import <collections.h>

#define MAX_LENGTH 400

@interface AgentModelSwarm: Swarm
{
  int numAgents;
  int InitNumObjects;  
  int InitNumStacks;	
  int seedValueObjects;	
  int seedValueLocAgt;  
  int worldXSize, worldYSize;
  int numIterations;
  int TypeOfSpace;
 
  id modelActions; // scheduling data structures
  id modelSchedule;

  id agentList; // list of all the agents
  id <Grid2d> worldAgent; //  the world, containing the agents
  WorldObject *worldObject; // worldObject contains only the objects
}

-convert: (char *)buf: (char *)buf1;
-getAgentList; // access methods into the
-(id <Grid2d>)getWorldAgent; // model swarm. These methods
-(WorldObject *)getWorldObject; // allow the model swarm to be observed.

-addAgent: (id) agt; // special method for demo
-(int)getHeap;
-(int)getMaxSize;
-(id)getStackListForHisto;

-(int)getNumAgents;

-(int)getSeedValueObj;
-(int)getSeedValueLocAgt;
-IncrementNumIterations;
-(int)getNumIterations;

-setModTypeOfSpace: (int)type_of_space;
-(int)getModTypeOfSpace;

+createBegin: (id) aZone;  // extra methods you provide for Swarms
-createEnd;
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

@end

/*
$Log: AgentModelSwarm.h,v $
Revision 1.4  1998/04/24 21:19:11  mgd
Revert WorldObject protocol things.

Revision 1.3  1998/04/24 01:52:45  mgd
* WorldObject.m: Include collections.h.

* WorldObject.h: Include space/Discrete2d.h.  Add a WorldObject
protocol.

* Stack.h: Include objectbase/SwarmObject.h instead of objectbase.h.

* AgentProbaCamera.h: Include objectbase/SwarmObject.h instead of
objectbase.h.
(AgentProbaCamera): Make worldAgent conform to the Grid2d protocol.

* AgentProbaCamera.[hm]:
Make setWorlds:wAgt: first argument conform to Grid2d protocol,
and second conform to the WorldObject protocol.

* AgentObserverSwarm.h (AgentObserverSwarm): Make envDisplay
conform to the Value2dDisplay protocol.  Make agentDisplay
conform to the Object2dDisplay protocol.

* AgentModelSwarm.h: Include objectbase/Swarm.h instead of
objectbase.h.  Make worldAgent an object conforming to the
Grid2d protocol, likewise for getter.  Make worldObject an
object conforming to the WorldObject protocol, likewise for getter.

Revision 1.2  1998/02/04 01:08:04  mgd
* main.m (main): Constify argv.

* WorldObject.m ([WorldObject -RemoveObjects:::]): Initialize
oldsize and newsize to avoid warning.

* Stack.h: Include objectbase.h instead of swarmobject.h.

* Makefile (APPLIBS): Remove -lneuro and -lga.

* AgentProbaCamera.m ([AgentProbaCamera -determinesIntervalAngle:]):
Initialize intervalAng to avoid warning.
([AgentProbaCamera -determinesAngle:]):
Initialize angle to avoid warning.
([AgentProbaCamera -drawSelfOn:]): Make argument to drawSelfOn:
an id <Raster> instead of being statically typed.

* AgentProbaCamera.h:  Include objectbase.h and gui.h
instead of swarmobject.h and tkobjc/Raster.h.
([-drawSelfOn:r]): Make argument to drawSelfOn: an id <Raster>
instead of being statically typed.

* AgentObserverSwarm.m: Include objectbase.h instead of
swarmobject.h.  Constify StackColors and descr.  Include
simtools.h and gui.h.
(-convert::): Initialize j to avoid warning.
([AgentObserverSwarm +createBegin:]): Make probeMap comply with
the ProbeMap protocol rather than being statically typed.
([AgentObserverSwarm -buildObjects]): Use
CREATE_ARCHIVED_PROBE_DISPLAY for agentModelSwarm and
AgentObserverSwarm.  Send waitForControlEvent to actionCache
rather than controlPanel.  Create colormap from Colormap instead
of XColormap. Use setDisplayWidget:colormap: rather than
setDisplayWidget:Colormap:.  Create StackGraph from Graph instead
of BLTGraph. Use renamed setTitle: and setAxisLabelX:Y:.  Likewise
for BiggestStackGraph and useHisto.
([AgentObserverSwarm -updateHisto]): Use renamed
drawHistogramWithInt:.

* AgentObserverSwarm.h: Include gui.h instead of tkobjc.h.
Include objectbase.h instead of swarmobject.h.
(AgentObserverSwarm): Make colormap comply with the Colormap
protocol instead of being statically typed to XColormap.
Make worldRaster comply with the ZoomRaster protocol instead of
being statically typed.  Make StackGraph and BiggestStackGraph
comply with the Graph protocol instead of being statically
typed to BLTGraph.  Make StackData and BiggestStackData comply
with the GraphElement protocol instead of being statically typed.
Make StackGrapher and BiggestStackGrapher comply with the
ActiveGraph protocol instead of being statically typed.  Make
useHisto comply with the Histogram protocol instead of being
statically typed to Histo.

* AgentModelSwarm.m ([AgentModelSwarm -convert::]): Initialize
j to avoid warning.
([AgentModelSwarm +createBegin:]): Use id <ProbeMap> instead of
statically typing probeMap.

* AgentModelSwarm.h: Change swarmobject.h to objectbase.h.

Revision 1.1.1.1  1998/02/03 23:40:03  mgd
EnhApp import

Revision 1.1  1997/04/02 08:59:58  chantem
Initial revision

Revision 1.1  1997/03/25 11:45:42  chantem
Initial revision

*/
